Subject: Re: IPv4/IPv6 sysctl unregistration deadlock

From: Patrick McHardy <[email-masked]>
Date: Wed, 25 Feb 2009 07:23:52 +0100

Herbert Xu wrote:
> On Wed, Feb 25, 2009 at 06:23:33AM +0100, Patrick McHardy wrote:
>> An easy fix would be to keep track of whether sysctl unregistration
>> is in progress in IPv4/IPv6 and ignore new requests from that point
>> on. Its not very elegant though, so I was wondering whether anyone
>> has a better suggestion.
> 
> We could make the unregistration asynchronous and invoke a callback
> when it's done.  Then we can simply hold a net_device refcount and
> relinquish it in the callback

That sounds simple enough. I'll see if I can come up with a patch, thanks.